Subject: Re: [PATCH 0/2] Disable forwarding of LRO skbs

From: Ben Hutchings <[email-masked]>
Date: Thu, 1 May 2008 13:08:51 +0100

Herbert Xu wrote:
> On Thu, May 01, 2008 at 12:18:08PM +0100, Kieran Mansley wrote:
> >
> > If I remember rightly it also gets upset when it comes to split the
> > packet because the frag_list is already in use; it expects this not to
> > be the case for GSO but it's valid for an LRO packet to do this I think.
> > I don't think there's anything fundamentally difficult here, it's just
> > that the code has never been written to cope.
> 
> Oh so LRO packets still preserve the original packet boundaries?
> That's even easier.  We could just make the GSO output code detect
> the presence of frag_list and fragment based on that.

Depending on the driver, the packets may be received into skbs which are
then attached to frag_list, or into page buffers which go in the frags
array.  If most packets can be merged by LRO, deferring skb allocation
and using the frags array is a performance win.

Ben.

-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.